
 
const nsIConsoleService = Components.interfaces.nsIConsoleService;
const nsISupports = Components.interfaces.nsISupports;

const SHAREDRES_CONTRACTID = '@scenari.com/sharedres;1';
const SHAREDRES_CID = Components.ID('{64896643-3859-4BDA-897E-5718725CE2A2}');
const SHAREDRES_IID = Components.interfaces.scISharedRes;



function scSharedRes() {
}


scSharedRes.prototype = {
	fSharedDom : {},
	fMaxTry    : 5,
	/* */
	
	getSharedDom: function(pUrl) {
		try{
			var vXml = this.fSharedDom[pUrl];

			if(vXml) {
				return vXml;
			}else{
				vTryNumber = 0;
				vMaxTry	   = 5;
				function fGetXml(){

					vTryNumber+=1;
					try{
						/*
						var vReq = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest); 
						vReq.open('GET', pUrl, false);
						vReq.send(null);  
						var vXml = vReq.responseXML;
						debug("vReq :::"+listProperties(vReq));
						debug("XML : "+vXml + ", document : " + vXml.documentElement +", getXml(vXml) : "+ (getXml(vXml)!=""));
						*/
						var vIoService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
						var vChannel = vIoService.newChannel(pUrl,null,null);
						vChannel.contentType = "text/xml";
						var vInput = vChannel.open();
						try {
							var vBuf = Components.classes["@mozilla.org/network/buffered-input-stream;1"].createInstance(Components.interfaces.nsIBufferedInputStream);
							vBuf.init(vInput, vChannel.contentLength);
							var vParser = Components.classes["@mozilla.org/xmlextras/domparser;1"].createInstance(Components.interfaces.nsIDOMParser);
							vXml = vParser.parseFromStream(vBuf, null, vChannel.contentLength, "text/xml");
						}finally {
							vInput.close();
						}
						if(!vXml && vTryNumber<vMaxTry){
							fGetXml();
						}
					}catch(e){
						if(vTryNumber<vMaxTry) fGetXml();
							else throw e;
					}
				}
				fGetXml();
				this.fSharedDom[pUrl] = vXml;
				return vXml;
			}
		} catch(e){
			debug("scSharedRes.getSharedDom(). Echec au chargement de : "+pUrl+" : "+e);
			return null;
		}
    },
    
    /**
     * Suppression du cache
     */
    reset: function() {
		try{
			this.fSharedDom = {};
		} catch(e){
			debug("scSharedRes.reset : " + e);
			return null;
		}
    },
    
    QueryInterface: function(pIID) {
            if (!pIID.equals(SHAREDRES_IID) &&
                !pIID.equals(nsISupports))
                    throw Components.results.NS_ERROR_NO_INTERFACE;
            return this;
    }
}



function debug(pText){
	var vConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(nsIConsoleService);
	vConsoleService.logStringMessage(pText);
}
function listProperties(pObj){
	var vRes = "";
	var vProp = null;
	for (vProp in pObj) {
		try {
			vRes += vProp +'(' + pObj[vProp]+ ')'+ "\n";
		} catch(e){
			vRes += vProp +' -> toString in error\n';
		}
	}
	return vRes;
}


var scModule = {
    registerSelf: function(compMgr, fileSpec, location, type) {
        compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
        compMgr.registerFactoryLocation(SHAREDRES_CID, 
                                        "scSharedRes service JS component", 
                                        SHAREDRES_CONTRACTID, 
                                        fileSpec, 
                                        location,
                                        type);
    },

    getClassObject: function(compMgr, cid, iid) {
        if (!cid.equals(SHAREDRES_CID))
            throw Components.results.NS_ERROR_NO_INTERFACE;

        if (!iid.equals(Components.interfaces.nsIFactory))
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

        return scSharedResSvcFactory;
    },

    canUnload: function(compMgr) { return true; }
};


var scSharedResSvcFactory = {
    createInstance: function(outer, iid) {
        if (outer != null)
            throw Components.results.NS_ERROR_NO_AGGREGATION;
    
        if (!iid.equals(SHAREDRES_IID) &&
            !iid.equals(Components.interfaces.nsISupports))
            throw Components.results.NS_ERROR_INVALID_ARG;

        return new scSharedRes();
    }
}


function NSGetModule(comMgr, fileSpec) { return scModule; }

